module mod_common_var

	use mod_types

	implicit none
		
	!----------------------------------------------------------------
	! 1. Calibration
	!----------------------------------------------------------------

	real (dp), parameter :: delta  = 0.0196 					! Depreciation
	real (dp), parameter :: alpha  = 0.4						! Capital Share 
	real (dp), parameter :: tau    = 2.d0						! risk aversion
	real (dp), parameter :: beta   = 0.9896 					! Discount factor
	real (dp), parameter :: theta  = 0.357						! Weight on consumptiomn
	real (dp), parameter :: rho    = 0.95						! Autoregressive 
	real (dp), parameter :: sigma  = 0.007						! Variance

	!----------------------------------------------------------------
	! 2. Numerical parameters
	!---------------------------------------------------------------- 

	integer :: n_tauchen = 41									! Number Tauchen points 
	integer :: Tsimul    = 50000								! Number of simulations for the EEerror

	real (dp), parameter :: toler   = 1e-6						! Numerical tolerance
	real (dp) :: step
	

end module mod_common_var