subroutine sub_golden(kend, K, grid_k, g_k1, length_grid_k)

! Golden Search Algorithm.

	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k
	
	real (dp), dimension(length_grid_k), intent(in) :: grid_k, g_k1
	real (dp), intent(in) :: K
	real (dp), intent(out) :: kend

	integer :: go_on

	real (dp) :: kend1, A, B, C, D, fB, fC

	A=K-1
	D=K+1
	B=0.6*A+0.4*D
	C=0.4*A+0.6*D

	call sub_myinterp(grid_k,g_k1,B,length_grid_k,kend1)
	fB=-abs(kend1-K)
	call sub_myinterp(grid_k,g_k1,C,length_grid_k,kend1)
	fC=-abs(kend1-K)

	go_on=1
	
	do while(go_on==1)

		if (fB>fC) then
			D=C
			C=B
			fC=fB
			B=0.6*C+0.4*A
			call sub_myinterp(grid_k,g_k1,B,length_grid_k,kend1)
			fB=-abs(kend1-K)
		else
			A=B
			B=C
			fB=fC
			C=0.6*B+0.4*D
			call sub_myinterp(grid_k,g_k1,C,length_grid_k,kend1)
			fC=-abs(kend1-K)
		endif

		if (abs(D-A)<0.000001) go_on=0

	enddo
	
	kend=B

end subroutine sub_golden
