subroutine sub_valueend1(value,grid_k,length_grid_k,y,transition,l_ss)
		
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k

	real(dp), dimension(length_grid_k,n_tauchen), intent(inout) :: value
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), dimension(n_tauchen), intent(in) :: y
	real(dp), intent(in) :: l_ss

	integer :: iter, index_k, index_z
	
	real(dp), dimension(length_grid_k,n_tauchen) :: cih, D, Cstar, Vend, Vend1, Yend, value1, kend
	real(dp) :: diff, B1, B2, B3

  iter = 0
  diff = 1000.d0

    ! Need to define "cash in hand" tomorrow.

	do index_k = 1,length_grid_k
		do index_z = 1,n_tauchen
			cih(index_k,index_z)=exp(y(index_z))*grid_k(index_k)**alpha*l_ss**(1-alpha)+(1-delta)*grid_k(index_k)
		enddo
	enddo

	! These parameters simplify the calculations later

	B1=(theta-1)*(1-tau)
	B2=1/(theta*(1-tau)-1)
	B3=theta*(1-tau)

	!Here we start the iterations.
	
	iter=0
	diff=1
	
	do while(diff>toler)
		iter=iter+1
		!Compute the derivatives of Vtilda at the grid points only.
		D(1,:)=(value(2,:)-value(1,:))/step
		D(length_grid_k,:)=(value(length_grid_k,:)-value(length_grid_k-1,:))/step
		do index_k = 2,length_grid_k-1
			D(index_k,:)=(value(index_k+1,:)-value(index_k-1,:))/(2.d0*step)
		enddo
			
		Cstar=(1/theta*D*(1-l_ss)**B1)**B2
		Vend=1/(1-tau)*Cstar**B3*(1-l_ss)**(-B1)+value
		
		do index_z = 1,n_tauchen
			Yend(:,index_z)=Cstar(:,index_z)+grid_k
			call sub_myinterp1(Yend(:,index_z),Vend(:,index_z), cih(:,index_z), length_grid_k, Vend1(:,index_z))	
		enddo
						
		do index_k = 1,length_grid_k
			do index_z = 1,n_tauchen
				value1(index_k,index_z)=beta*dot_product(transition(index_z,:),Vend1(index_k,:))	
			enddo
		enddo
		
		diff = maxval(abs(value-value1))
		
		value=value1
		if (mod(iter,100)==0) print *, 'Iteration: ', iter, 'Tolerance ', diff
		
	enddo

	!The only variable that we need out of this program is Vend1 since it is already defined on grid_k.
	value=Vend1*(1-beta)

end subroutine sub_valueend1