subroutine sub_valueend2(value,grid_k,length_grid_k,y,transition,kend,g_l,diffstandard)
		
	use mod_types
	use mod_common_var

	implicit none

	integer, intent(in) :: length_grid_k

	real(dp), dimension(length_grid_k,n_tauchen), intent(inout) :: value
	real(dp), dimension(length_grid_k,n_tauchen), intent(in) :: kend, g_l
	real(dp), dimension(n_tauchen,n_tauchen), intent(in) :: transition
	real(dp), dimension(length_grid_k), intent(in) :: grid_k
	real(dp), dimension(n_tauchen), intent(in) :: y
	real(dp), intent(in) :: diffstandard

	integer :: iter, index_k, index_z, deriv

	real(dp), dimension(length_grid_k,n_tauchen) :: cih, D, Cstar, Vend, Vend1, Yend, value1, L1
	real(dp), dimension(length_grid_k,4) :: X
	real(dp), dimension(4,4) :: XX, XXinv
	real(dp), dimension(4) :: betahat
	real(dp) :: diff, B1, B2, B3

  iter = 0
  diff = 1000.d0

    ! Need to interpolate the policy function and the value function at the new Kend values

	do index_z = 1,n_tauchen
		call sub_myinterp1(grid_k, g_l(:,index_z), kend(:,index_z), length_grid_k, L1(:,index_z))
	enddo
	Vend1=value

	! These parameters simplify the calculations later

	B1=(theta-1)*(1-tau)
	B2=1/(theta*(1-tau)-1)
	B3=theta*(1-tau)

	!Options for the derivative
	deriv=2 !1 is the usual method, 2 is the polynomial.
	
	if (deriv==2) then
		do index_k = 1,length_grid_k
			X(index_k,1) = 1.d0
			X(index_k,2) = grid_k(index_k)
			X(index_k,3) = grid_k(index_k)**2
			X(index_k,4) = grid_k(index_k)**3
		enddo
		call dlinrg(4, matmul(transpose(X),X), 4, XXinv, 4)
	endif
	
	!Here we start the iterations.
	iter=0
	diff=1

	do while(diff>0.1d0*diffstandard)
		
		iter=iter+1
		do index_k = 1,length_grid_k
			do index_z = 1,n_tauchen
				value(index_k,index_z)=beta*dot_product(transition(index_z,:),Vend1(index_k,:))	
			enddo
		enddo
		
		!Compute the derivatives of Vtilda at the grid points only.
		if (deriv==1) then
			!Compute the derivatives using a linear system.
			D(1,:)=(value(2,:)-value(1,:))/step
			D(length_grid_k,:)=(value(length_grid_k,:)-value(length_grid_k-1,:))/step
			do index_k = 2,length_grid_k-1
				D(index_k,:)=(value(index_k+1,:)-value(index_k-1,:))/(2.d0*step)
			enddo
		else
			!Derivative using the regression.
			do index_z =1,n_tauchen
				betahat = matmul(XXinv,matmul(transpose(X),value(:,index_z)))
				D(:,index_z) = betahat(2) + 2.d0*betahat(3)*grid_k + 3.d0*betahat(4)*grid_k**2
			enddo
		endif
			
		Cstar=(1/theta*D*(1-L1)**B1)**B2
		Vend=1/(1-tau)*Cstar**B3*(1-L1)**(-B1)+value
		do index_k = 1,length_grid_k
			do index_z = 1,n_tauchen
				call sub_kendogenousnewton(kend(index_k,index_z),y(index_z),L1(index_k,index_z),Cstar(index_k,index_z),grid_k(index_k))
			enddo
		enddo
		
		do index_z = 1,n_tauchen
			call sub_myinterp1(kend(:,index_z), Vend(:,index_z), grid_k, length_grid_k, value1(:,index_z))
			call sub_myinterp1(grid_k, g_l(:,index_z), kend(:,index_z), length_grid_k, L1(:,index_z))
		enddo
				
		diff = maxval(abs(value1-Vend1))
		Vend1=value1
		if (mod(iter,10)==0) print *, 'Iteration: ', iter, 'Tolerance ', diff
	enddo

	!The only variable that we need out of this program is Vend1 since it is already defined on grid_k.
	value=value1*(1-beta)

end subroutine sub_valueend2