subroutine sub_grid_generation(cover,length_grid_k,k_ss,grid_k)

	use mod_types
	use mod_common_var

	implicit none
	
	integer, intent(in) :: length_grid_k

	real(dp), intent(in) :: cover, k_ss
	real(dp), dimension(length_grid_k), intent(out) :: grid_k

	integer :: index_grid

	grid_k(1) = (1-cover)*k_ss
	step = 2.d0*cover*k_ss/(length_grid_k-1.d0)

	do i1 = 2, length_grid_k
		grid_k(i1) = grid_k(i1-1)+step
	enddo
	
	print *,' ' 
	print*, 'Grid generated with ',length_grid_k,'grid points with step size of', step ,'and coverage of +-', cover*100, 'percent'
	print *,' ' 
	
	open(unit=14, file='grid_k.txt', status = 'replace')
	write (14, '(f20.10)') (grid_k(i1), i1 = 1,length_grid_k)
	close(14) 

end subroutine sub_grid_generation

